<?php
/*
	CREATED BY: Yasser Khan
	Date: Feb 13th 2008
	modified August 13th 2008
	
	Runs as a cron job, and sends email to all address from
	database to recieve notification of the OOP listings
	
	THIS IS THE CUSTOM REPORT
	
*/
require($_SERVER['DOCUMENT_ROOT'] . "/outofprint_v2/config/config.php");
require(OCI_FNX);
require(MAILER);
db_connect();
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Out of Print Notification - Non Custom Report Notification</title>
</head>

<body>
Out of Print Notification - Custom Report Notification
<br />
  <br />
  <form action="" method="post">
  <input type="submit" name="Submit" id="Submit" value="Send Notification" onclick="return confirm('Are you sure you want to do this?\nOkay, just making sure.');"/>
  <input type="submit" name="Report" id="Report" value="Report Only" />
  </form>
<?php
if (isset($_POST['Submit']) or isset($_POST['Report'])) { //run the loop if either Submit or Report are set

	//$sql = "SELECT * FROM WEB_OUT_OF_PRINT_CUSTOM WHERE UNSUBSCRIBE = 'N'";
	// will only select those that havn't sent the report in the past day
	$sql = "SELECT * FROM WEB_OUT_OF_PRINT_CUSTOM WHERE UNSUBSCRIBE = 'N' AND STATUS=1 AND LAST_NOTIFY < SYSDATE-1";
	
	$stmt = db_query($sql);
	$num_rows = db_num_rows($stmt);
	
	$stmt = db_query($sql);
	$results = db_results($stmt);
	
	// here we push all the required info for a customer into an array
	$customer_info = array();
    /**
     * Setting limit to number of recipients
     * @see https://jira.mheducation.com/browse/ICAB-638
     */
    $limit = $num_rows;

	// only send out 30 at a time
	for($i=0; $i<$limit; $i++) {
		
		// convert S or B into 1 or 2
		$billto_or_shipto = $results['BILLTO_OR_SHIPTO'][$i];

		if ($billto_or_shipto == "S") {
			$billto_or_shipto = "1";
		} else {
			$billto_or_shipto = "2";
		}
		
		// gets the account name from web out of print table
		$account_name = get_account_name($results['ACCOUNT_NUMBER'][$i], $billto_or_shipto);

		array_push($customer_info, $results['HASHED_ACCOUNT_NUMBER'][$i] . '|' . $results['E_MAIL'][$i] . '|' . $billto_or_shipto . '|' . $results['CUSTOMER_NAME'][$i] . '|' . $account_name . '|' . $results['ACCOUNT_NUMBER'][$i] . '|' . $results['ACCOUNT_ID'][$i] . '|' . $results['HASHED_ACCOUNT_ID'][$i]);
	
	}

	/*
		DECLARE ARRAYS FOR USE
		IN REPORT EMAIL
	*/
	$email_report           = array();
	$customer_number_report = array();
	$account_name_report    = array();
	$customer_name_report   = array();
	$link_90_report         = array();
	$link_12_report         = array();
	$export_link_90_report  = array();
	$export_link_12_report  = array();
	$count_for_90_days_a    = array();
	$count_for_12_months_a  = array();



	/*
		START PHPMAILER ROUTINE
	*/
	$mail = new PHPMailer();
	//$mail->IsSMTP();
	$mail->IsHTML(true);
	$mail->SMTPKeepAlive = true; //keeps connection open
	
	//set the From email address
	$mail->From     = "canada.webmaster@mheducation.com";
	$mail->FromName = "Webmaster";
	$mail->Subject = "McGraw-Hill Out of Print Notification - ".date('l dS \of F Y');
	
	$counter = 0;
	
	foreach ($customer_info as $customer_values) {
		/*
			$customer_values is now an array containing six elements
			
			$customer_values[0] = HASHED ACCOUNT NUMBER
			$customer_values[1] = E_MAIL
			$customer_values[2] = BILLTO_OR_SHIPTO
			$customer_values[3] = CUSTOMER_NAME
			$customer_values[4] = ACCOUNT_NAME
			$customer_values[5] = ACCOUNT_NUMBER
			$customer_values[6] = ACCOUNT_ID
			$customer_values[7] = HASHED_ACCOUNT_ID
			
		*/
		$customer_values = explode('|', $customer_values);
		
		$hashedAcountNumber = $customer_values[0];
		$email              = $customer_values[1];
		$billToOrShipTo     = $customer_values[2];
		$customerName       = $customer_values[3];
		$accountName        = $customer_values[4];
		$accountNumber      = $customer_values[5];
		$accountID          = $customer_values[6];
		$hashedAccountID    = $customer_values[7];
				
		$date_90_days = date('F d, Y',mktime(0, 0, 0, date('m')-3, date('d'), date('Y')));
		$link_90_days = "Out of Print Report - Past 90 Days from " . date("F d, Y") . " to " . $date_90_days;
		$date_12_months = date('F d, Y',mktime(0, 0, 0, date('m')-12, date('d'), date('Y')));
		$link_12_months =  "Out of Print Report - Past 12 Months from " . date("F d, Y") . " to " . $date_12_months;
		
		// function returns array, [0] = row count for 90 days, [1] = row count for 12 months
		$row_count_array = customer_data_count($customer_values[5], $customer_values[2]);
		$count_for_90_days   = $row_count_array[0];
		$count_for_12_months = $row_count_array[1];

		/*
		
			PUSH VALUES TO ARRAY FOR USE
			IN REPORT EMAIL
		
		*/
		
		// generate arrays for report email that will be sent to the business managers and admins
		
		array_push($email_report,           $email);
		array_push($customer_number_report, $accountNumber);
		array_push($account_name_report,    $accountName);
		array_push($link_90_report,         "https://tools.mheducation.ca/outofprint/client-oop.php?q=".$hashedAcountNumber.",90,".$billToOrShipTo);
		array_push($link_12_report,         "https//tools.mheducation.ca/outofprint/client-oop.php?q=".$hashedAcountNumber.",12,".$billToOrShipTo);
		array_push($export_link_90_report,  "https://tools.mheducation.ca/outofprint/export-client-oop.php?q=".$hashedAcountNumber.",90,".$billToOrShipTo);
		array_push($export_link_12_report,  "https://tools.mheducation.ca/outofprint/export-client-oop.php?q=".$hashedAcountNumber.",12,".$billToOrShipTo);
		array_push($customer_name_report,   $customerName);
		array_push($count_for_90_days_a,    $count_for_90_days);
		array_push($count_for_12_months_a,  $count_for_12_months);
		
		if (isset($_POST['Submit'])) { // but only send the custom emails if Submit is set
	
			//require the template file
			require(DOCU_HOST . "/templates/oop_email_customer.php");
			$mail->Body = $oop_email_body;
			$mail->AltBody = strip_tags($oop_email_body_plain);
			
			// sends email to actual client email address
			$mail->AddAddress($email); // comment this out to prevent accedental submissions
	
			if ($mail->Send()) {
				updateLastNotify($email, 'custom', $accountID);
			}
		
			$mail->ClearAddresses();
		
			if (!$mail->ErrorInfo) {
				$counter++;
			} else {
				sendErrorMail("Failed to send oop notify!", "couldn't send (".$email.") the oop report for some reason, please check cron job file or get help.\n\n\n\n" . $mail->ErrorInfo);
			}
		
		}

	}
	
	if (isset($_POST['Submit'])) echo $counter . " emails were sent sucessfully!";
	
	$mail->SmtpClose();
}	
	
	
	
	
	
	
	
if (isset($_POST['Report'])) { // run the reports if Report is set
	/*
		SEND EMAIL TO BUSINESS MANAGERS
	*/

	// file grabs array of recipients
	require(DOCU_HOST . "/includes/email_report_recipients.php");
	
	$number_of_customers = count($email_report);
	
	$mail = new PHPMailer();
	$mail->IsSMTP();
	$mail->IsHTML(true);
	
	$mail->From     = "webmaster@mheducation.ca";
	$mail->FromName = "Webmaster";
	
	$mail->Subject = "McGraw-Hill Out of Print Notification - ".date('l dS \of F Y');


	$counter = 0;
	foreach ($report_recipients as $recipient) {
		
		//include the template file
		require(DOCU_HOST . "/templates/oop_email_internal_report.php");
		
		$mail->AddAddress($recipient);
		$mail->Body = $oop_email_internal;
		$mail->Send();
		$mail->ClearAddresses();
		$counter++;
	}

	if ($mail->ErrorInfo) sendErrorMail("Failed to send oop email report!", "couldn't send the oop email report for some reason, please check cron job file or get help.");
	
	echo "<br>(".$counter.") reporting done!";
	
}

?>
